
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <improv/improv.h>


void test1(void)
{
	ImprovSocket *sock;
	ImprovData *data,*x;
	int i;

	sock=improv_socket_new();

	data=improv_data_new();

	improv_object_dump(IMPROV_OBJECT(data));

	data->value=12;

	improv_socket_write(sock,data);

	i=improv_socket_read(sock,&x,0);
	
	printf("i=%d\n",i);

	improv_object_dump(IMPROV_OBJECT(x));
}

int handler(ImprovObject *data,int x,void *arg)
{
	printf("handler\n");
	improv_object_dump(data);

	return 0;
}

void test2(void)
{
	ImprovData *data;

	data=improv_data_new();
	improv_object_dump(IMPROV_OBJECT(data));

	improv_signal_connect(IMPROV_OBJECT(data),ImprovSignalUpdate,handler,NULL);

	improv_signal_emit(IMPROV_OBJECT(data),ImprovSignalUpdate);

	improv_signal_marshal_one();
}

void test3(void)
{
	ImprovTime time;

	improv_time_get_current(&time);

	printf("%d.%06d\n",(int)time.tv_sec,(int)time.tv_usec);
}

void test4(void)
{
	ImprovData *data;
	ImprovSocket *sock;
	ImprovLog *log;

	sock=improv_socket_new();
	log=improv_log_new("log",stdout);

	data=improv_data_new();
	data->value=10.0;
	improv_object_dump(IMPROV_OBJECT(data));

#if 0
	improv_socket_connect(sock,log->in);
#endif

	improv_socket_write(log->in,data);

#if 0
	improv_signal_emit(IMPROV_OBJECT(log->in),ImprovSignalUpdate);
#endif
}

void test5(void)
{
	ImprovData *data;
	ImprovSocket *sock;
	ImprovLog *log;

	sock=improv_socket_new();
	log=improv_log_new("log",stdout);

	data=improv_data_new();
	data->value=10.0;
	improv_object_dump(IMPROV_OBJECT(data));

	improv_socket_connect(sock,log->in);

	improv_socket_write(sock,data);
}

int main(int argc,char *argv[])
{
	test5();

	improv_main();

	return 0;
}

