
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <improv/improv.h>

static int update_signal(ImprovObject *obj,int type,void *arg);
static int update_request_signal(ImprovObject *obj,int type,void *arg);
static int filter_some_data(ImprovFilter *filter);

ImprovClass improv_filter_class={
	name:	"ImprovFilter",
	size:	sizeof(ImprovFilter),
	dump:	improv_filter_dump,
	parent:	&improv_object_class,
};

void improv_filter_dump(ImprovObject *it)
{
	ImprovFilter *filter=IMPROV_FILTER(it);

	printf("\tack: %p\n",filter);
}

ImprovFilter *improv_filter_new(void)
{
	ImprovFilter *it;

	it=IMPROV_FILTER(improv_object_new(&improv_filter_class));

	it->in=improv_socket_new();
	improv_signal_connect(IMPROV_OBJECT(it->in),ImprovSignalUpdate,
		update_signal,it);

	it->out=improv_socket_new();
	improv_signal_connect(IMPROV_OBJECT(it->out),ImprovSignalUpdateRequest,
		update_request_signal,it);
	
	return it;
}

static int update_request_signal(ImprovObject *obj,int type,void *arg)
{
	ImprovFilter *filter=IMPROV_FILTER(arg);

	improv_signal_emit(IMPROV_OBJECT(filter->in),ImprovSignalUpdateRequest);

	return 0;
}


static int update_signal(ImprovObject *obj,int type,void *arg)
{
	ImprovFilter *filter=IMPROV_FILTER(arg);

	filter_some_data(filter);

#if 0
	improv_signal_emit(filter->out,ImprovSignalUpdate);
#endif

	return 0;
}

static int filter_some_data(ImprovFilter *filter)
{
	ImprovData *data=NULL;

	while(improv_socket_read(filter->in,&data,0)){
		filter->filter_func(data,filter->filter_arg);
		improv_socket_write(filter->out,data);
	}

	return 0;
}

