
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <improv/improv.h>

static int update_signal(ImprovObject *obj,int type,void *arg);

ImprovClass improv_log_class={
	name:	"ImprovLog",
	size:	sizeof(ImprovLog),
	dump:	improv_log_dump,
	parent:	&improv_object_class,
};

void improv_log_dump(ImprovObject *it)
{
	ImprovLog *log=IMPROV_LOG(it);

	printf("\tlog: %p\n",log->out);
}

ImprovLog *improv_log_new(const char *name,FILE * output)
{
	ImprovLog *it;

	it=IMPROV_LOG(improv_object_new(&improv_log_class));

	it->in=improv_socket_new();
	improv_signal_connect(IMPROV_OBJECT(it->in),ImprovSignalUpdate,update_signal,it);

	it->name=name;	/* FIX */
	it->out=output;

	return it;
}


static int update_signal(ImprovObject *obj,int type,void *arg)
{
	ImprovLog *log=IMPROV_LOG(arg);
	ImprovData *data=NULL;
	ImprovTime time;
	char *time_string;

	while(improv_socket_read(log->in,&data,0)){
		improv_time_get_current(&time);
		time_string=improv_time_print(&time);
		fprintf(log->out,"%s: %s: %g\n",time_string,log->name,data->value);
		improv_object_destroy(IMPROV_OBJECT(data));
		free(time_string);
	}
	return 0;
}

